import numpy as np
import pandas as pd
import torch
import torch.nn as nn
import torch.functional as F
import torch.optim as optim
from torch.utils.data import DataLoader, Dataset
from sklearn.metrics import accuracy_score, precision_score, recall_score, f1_score

class NeuralNetwork(nn.Module):
  def __init__(self, input_features = None, output_dimension = None):
    super().__init__()
    
    self.NN = self.fully_connceted_layer(in_features = 5, out_features = 3, dropout_ratio = 0.2)

  def fully_connceted_layer(self, in_features = None, out_features = None, dropout_ratio = None):
    return nn.Sequential(
        nn.Linear(in_features = in_features,\
                  out_features = 16,\
                  bias = True),
        nn.ReLU(inplace = True),
        nn.BatchNorm1d(num_features = 16),\
        nn.Dropout(p = dropout_ratio),

        nn.Linear(in_features = 16,\
                  out_features = 8,\
                  bias = True),
        nn.ReLU(inplace = True),
        nn.BatchNorm1d(num_features = 8),\
        nn.Dropout(p = dropout_ratio),

        nn.Linear(in_features = 8,\
                  out_features = out_features,\
                  bias = True),
        nn.Softmax()

    )

  def forward(self, x):
    x = self.NN(x)

    if x is not None:
      return x
    else:
      return -1

  
  
  ####################################################################
  
  '''Call the optimizer & loss function'''
  
  
  
  
  if __name__ == "__main__":
      model = NeuralNetwork(input_features = 5, output_dimension = 3)
