import torch
from torch.utils.data import DataLoader, Dataset
from sklearn.model_selection import train_test_split

class TrainTestSplit:
    def __init__(self, dataset = None):
        self.dataset = dataset
        
        # '''Do the train and test split'''
        # split = self.train_test_split(dataset = self.dataset)
    
    def train_test_split(self, dataset):
        X = dataset.iloc[:, :-1].values
        y = dataset.iloc[:, -1].values

        X = torch.tensor(data = X, dtype = torch.float32)
        y = torch.tensor(data = y, dtype = torch.float32)

        X_train, X_test, y_train, y_test = train_test_split(X, y, test_size = 0.25, random_state = 42)

        TRAIN_LOADER = DataLoader(dataset = list(zip(X_train, y_train)), batch_size = 32, shuffle = True)
        TEST_LOADER  = DataLoader(dataset = list(zip(X_test, y_test)), batch_size = 32, shuffle = True)
        
        train_data, train_label = next(iter(TRAIN_LOADER))
        test_data,  test_label  = next(iter(TEST_LOADER))
        
        print("train data with batch is  # {} ".format(train_data.shape),'\n')
        print("train label with batch is # {} ".format(train_label.shape),'\n')
        
        print("test data with batch is   # {} ".format(test_data.shape),'\n')
        print("test label with batch is  # {} ".format(test_label.shape),'\n\n')
        
        print("_"*100,'\n')
        
        
        return TRAIN_LOADER, TEST_LOADER